;
;*******************************************************
;*******************************************************
;**                                                   **
;**  Biblioteka procedur obslugi arytmetyki 32 bit    **
;**                                                   **
;**              Andrzej Pawluczuk                    **
;**                                                   **
;**             Mikrokontroler: AVR                   **
;**                                                   **
;**               Bialystok, 2006                     **
;**                                                   **
;*******************************************************
;*******************************************************
;
;
;-----------------------------------------------------------------------------
NegArg1		:				;PROCEDURE NegArg1 ( ) ;
;****************				;  Argument1 := - Argument1 ;
;						;BEGIN (* NegArg1 *)
	com	Argument1LL			;
	com	Argument1LH			;
	com	Argument1HL			;
	com	Argument1HH			;
	ldi	acc,1				;
	add	Argument1LL,acc			;
	ldi	acc,0				;
	adc	Argument1LH,acc			;
	adc	Argument1HL,acc			;
	adc	Argument1HH,acc			;
	ret					;END (* NegArg1 *) ;
;-----------------------------------------------------------------------------
NegArg2		:				;PROCEDURE NegArg2 ( ) ;
;****************				;  Argument2 := - Argument2 ;
;						;BEGIN (* NegArg2 *)
	com	Argument2LL			;
	com	Argument2LH			;
	com	Argument2HL			;
	com	Argument2HH			;
	ldi	acc,1				;
	add	Argument2LL,acc			;
	ldi	acc,0				;
	adc	Argument2LH,acc			;
	adc	Argument2HL,acc			;
	adc	Argument2HH,acc			;
	ret					;END (* NegArg2 *) ;
;-----------------------------------------------------------------------------
MultAgr1And10	:				;PROCEDURE MultAgr1And10 ( ) ;
;							Argument1 := Argument1 * 10 ;
;							Argument1 - 32 bit (NB)
;****************				;BEGIN (* MultAgr1And10 *)
	rcall	_ShiftArgument1			; Argument1 := Argument1 * 2 ;
	mov	WorkRegLL,Argument1LL		; WorkReg := Argument1 ;
	mov	WorkRegLH,Argument1LH		;
	mov	WorkRegHL,Argument1HL		;
	mov	WorkRegHH,Argument1HH		;
	rcall	_ShiftArgument1			; Argument1 := Argument1 * 4 ;
	rcall	_ShiftArgument1			;
	add	Argument1LL,WorkRegLL		; Argument1 := Argument1 + WorkReg ;
	adc	Argument1LH,WorkRegLH		;
	adc	Argument1HL,WorkRegHL		;
	adc	Argument1HH,WorkRegHH		;
	ret					;END (* MultAgr1And10 *) ;
_ShiftArgument1	:				;
	lsl	Argument1LL			;
	rol	Argument1LH			;
	rol	Argument1HL			;
	rol	Argument1HH			;
	ret					;
;-----------------------------------------------------------------------------
MultArg1AndArg2 :				;PROCEDURE MultArg1AndArg2 ( ) ;
;							Result := Argument1 * Argument2 ;
;								  16 bit * 16 bit
;*****************				;BEGIN (* MultArg1AndArg2 *)
	rcall	_InitDivMult			;
	ldi	acc,16				;
	mov	DivLoopCounter,acc		;
Mul_0	:					;
	rcall	_ShiftResult			;
	lsl	Argument2LL			;
	rol	Argument2LH			;
	brcc	Mul_1				;
	ldi	acc,0				;
	rcall	_AddArg1ToResult		;
Mul_1	:					;
	dec	DivLoopCounter			;
	brne	Mul_0				;
	ret					;END (* MultArg1AndArg2 *) ;
_ShiftResult :					;
	lsl	ResultLL			;
	rol	ResultLH			;
	rol	ResultHL			;
	rol	ResultHH			;
	ret					;
_InitDivMult :					;
	clr	acc				;
	mov	ResultLL,acc			;
	mov	ResultLH,acc			;
	mov	ResultHL,acc			;
	mov	ResultHH,acc			;
	mov	WorkRegLL,acc			;
	mov	WorkRegLH,acc			;
	mov	WorkRegHL,acc			;
	mov	WorkRegHH,acc			;
	ret					;
_AddArg1ToResult :				;
	add	ResultLL,Argument1LL		;
	adc	ResultLH,Argument1LH		;
	adc	ResultHL,acc			;
	adc	ResultHH,acc			;
	ret					;
;-----------------------------------------------------------------------------
MultArg1AndArg2U2 :				;PROCEDURE MultArg1AndArg2U2 ( ) ;
;							Result := Argument1 * Argument2 ;
;								  16 bit * 16 bit
;*****************				;BEGIN (* MultArg1AndArg2U2 *)
	rcall	_InitDivMult			;
	ldi	acc,15				;
	mov	DivLoopCounter,acc		;
	lsl	Argument2LL			;
	rol	Argument2LH			;
	brcc	MultU2_3			;
	mov	ResultLL,Argument1LL		;
	mov	ResultLH,Argument1LH		;
	com	ResultLL			;
	com	ResultLH			;
	ldi	acc,1				;
	add	ResultLL,acc			;
	ldi	acc,0				;
	adc	ResultLH,acc			;
	mov	acc,ResultLH			;
	rol	acc				;
	rol	ResultHL			;
MultU2_3:					;
MultU2_0:					;
	rcall	_ShiftResult			;
	lsl	Argument2LL			;
	rol	Argument2LH			;
	brcc	MultU2_1			;
	mov	acc,Argument1LH			;
	rol	acc				;
	ldi	acc,0				;
	sbci	acc,0				;
	rcall	_AddArg1ToResult		;
MultU2_1:					;
	dec	DivLoopCounter			;
	brne	MultU2_0			;
	ret					;END (* MultArg1AndArg2U2 *) ;
;-----------------------------------------------------------------------------
DivModArg1By10 :				;PROCEDURE DivModArg1By10 ( ) ;
;							Argument2 := Argument1 DIV 10 ;
;							WorkRegLL := Argument1 MOD 10 ;
;							Argument1, Argument2 - 32 bit
;*****************				;BEGIN (* DivModArg1By10 *)
	clr	acc				;
	mov	Argument2LL,acc			;
	mov	Argument2LH,acc			;
	mov	Argument2HL,acc			;
	mov	Argument2HH,acc			;
	mov	WorkRegLL,acc			;
	mov	WorkRegLH,acc			;
	mov	WorkRegHL,acc			;
	mov	WorkRegHH,acc			;
	ldi	acc,32				;
	mov	DivLoopCounter,acc		;
DiMo_0	:					;
	rcall	_ShiftArgument1			;
	rol	WorkRegLL			;
	ldi	acc,10				;
	cp	WorkRegLL,acc			;
	brcs	DiMo_3				;
DiMo_2	:					;
	sec					;
	rol	Argument2LL			;
	rol	Argument2LH			;
	rol	Argument2HL			;
	rol	Argument2HH			;
	ldi	acc,10				;
	sub	WorkRegLL,acc			;
	rjmp	DiMo_4				;
DiMo_3	:					;
	lsl	Argument2LL			;
	rol	Argument2LH			;
	rol	Argument2HL			;
	rol	Argument2HH			;
DiMo_4	:					;
	dec	DivLoopCounter			;
	brne	DiMo_0				;
	ret					;END (* DivModArg1By10 *) ;
;-----------------------------------------------------------------------------
DivideArg1ByArg2Round :				;PROCEDURE DivideArg1ByArg2Round ( ) ;
;							Result := Argument1 DIV Argument2 ;
;								  32 bit / 16 bit
;*****************				;BEGIN (* DivideArg1ByArg2Round *)
	mov	acc,Argument2LL			;
	or	acc,Argument2LH			;
	breq	DivRound_1			;
	rcall	_InitDivMult			;
	ldi	acc,32				;
	mov	DivLoopCounter,acc		;
DivRound_0:					;
	rcall	_ShiftArgument1			;
	rol	WorkRegLL			;
	rol	WorkRegLH			;
	brcs	DivRound_2			;
	cp	WorkRegLL,Argument2LL		;
	cpc	WorkRegLH,Argument2LH		;
	brcs	DivRound_3			;
DivRound_2:					;
	rcall	_SpShiftResult			;
	sub	WorkRegLL,Argument2LL		;
	sbc	WorkRegLH,Argument2LH		;
	rjmp	DivRound_4			;
DivRound_3:					;
	rcall	_ShiftResult			;
DivRound_4:					;
	dec	DivLoopCounter			;
	brne	DivRound_0			;
	lsl	WorkRegLL			;
	rol	WorkRegLH			;
	cp	WorkRegLL,Argument2LL		;
	cpc	WorkRegLH,Argument2LH		;
	brcs	DivRound_5			;
	ldi	acc,1				;
	add	ResultLL,acc			;
	ldi	acc,0				;
	adc	ResultLH,acc			;
	adc	ResultHL,acc			;
	adc	ResultHH,acc			;
DivRound_5:					;
	clv					;
	ret					;
DivRound_1:					;
	rcall	_SetInvResult			;
	ret					;END (* DivideArg1ByArg2Round *) ;
_SpShiftResult :				;
	sec					;
	rol	ResultLL			;
	rol	ResultLH			;
	rol	ResultHL			;
	rol	ResultHH			;
	ret					;
_SetInvResult	:				;
	ldi	acc,0xFF			;
	mov	ResultLL,acc			;
	mov	ResultLH,acc			;
	mov	ResultHL,acc			;
	mov	ResultHH,acc			;
	ldi	acc,0				;
	mov	WorkRegLL,acc			;
	mov	WorkRegLH,acc			;
	mov	WorkRegHL,acc			;
	mov	WorkRegHH,acc			;
	sev					;
	ret					;
;-----------------------------------------------------------------------------
DivideArg1ByArg2Fract :				;PROCEDURE DivideArg1ByArg2Fract ( ) ;
;							Result := Argument1 DIV Argument2 ;
;								  32 bit / 16 bit
;                                                       WorkReg := Argument1 MOD Argument2 ;
;*****************				;BEGIN (* DivideArg1ByArg2Fract *)
	mov	acc,Argument2LL			;
	or	acc,Argument2LH			;
	breq	DivFra_1			;
	rcall	_InitDivMult			;
	ldi	acc,32				;
	mov	DivLoopCounter,acc		;
DivFra_0:					;
	rcall	_ShiftArgument1			;
	rol	WorkRegLL			;
	rol	WorkRegLH			;
	brcs	DivFra_2			;
	cp	WorkRegLL,Argument2LL		;
	cpc	WorkRegLH,Argument2LH		;
	brcs	DivFra_3			;
DivFra_2:					;
	rcall	_SpShiftResult			;
	sub	WorkRegLL,Argument2LL		;
	sbc	WorkRegLH,Argument2LH		;
	rjmp	DivFra_4			;
DivFra_3:					;
	rcall	_ShiftResult			;
DivFra_4:					;
	dec	DivLoopCounter			;
	brne	DivFra_0			;
	clv					;
	ret					;
DivFra_1:					;
	rcall	_SetInvResult			;
	ret					;END (* DivideArg1ByArg2Fract *) ;
;-----------------------------------------------------------------------------
.exit
