;
;*******************************************************
;*******************************************************
;**                                                   **
;**          Modul obslugi sumy CRC 16-bitowej        **
;**                                                   **
;**              Andrzej Pawluczuk                    **
;**                                                   **
;**              Mikrokontroler: AVR                  **
;**                                                   **
;*******************************************************
;*******************************************************
;
.message	"***>>> Dolaczenie bibioteki obslugi CRC 16"
;-----------------------------------------------------------------------------
	.dseg
;-----------------------------------------------------------------------------
;						;VAR
CRC16Sum :		.byte	2		; CRC16Sum : WORD ;
WorkCRC :		.byte	2		; WorkCRC : WORD ;
;-----------------------------------------------------------------------------
	.cseg
;-----------------------------------------------------------------------------
_CRCTable :	.dw	0x00000 , 0x0CC01 , 0x0D801 , 0x01400
                .dw	0x0F001 , 0x03C00 , 0x02800 , 0x0E401
                .dw	0x0A001 , 0x06C00 , 0x07800 , 0x0B401
                .dw	0x05000 , 0x09C01 , 0x08801 , 0x04400
;-----------------------------------------------------------------------------
_CRCGetTabElem :				;FUNCTION _CRCGetTabElem ( A [param]: BYTE ) : WORD[x] ;
;**************					;BEGIN (* _CRCGetTabElem *)
	pushz					; _CRCGetTabElem := _CRCTable [ A DIV 16 ] ;
	andi	param,0x0F			;
	lsl	param				;
	ldz	_CRCTable<<1			;
	add	zl,param			;
	ldi	acc,0				;
	adc	zh,acc				;
	lpm					;
	mov	xl,r0				;
	adiw	zl,1				;
	lpm					;
	mov	xh,r0				;
	popz					;
	ret					;END (* _CRCGetTabElem *) ;
;-----------------------------------------------------------------------------
CRCNibleService	:				;PROCEDURE CRCNibleService ( Data[param] : BYTE ) ;
;****************				;BEGIN (* CRCNibleService *)
	push	param				;
	lds	param,CRC16Sum			; WorkCRC := _CRCGetTabElem ( CRC16Sum ) ;
	rcall	_CRCGetTabElem			;
	sts	WorkCRC+1,xh			;
	sts	WorkCRC,xl			;
	lds	acc,CRC16Sum			; CRC16Sum := CRC16Sum >> 4 ;
	lds	acc2,CRC16Sum+1			;
	lsr	acc2				;
	ror	acc				;
	lsr	acc2				;
	ror	acc				;
	lsr	acc2				;
	ror	acc				;
	lsr	acc2				;
	ror	acc				;
	sts	CRC16Sum,acc			;
	sts	CRC16Sum+1,acc2			;
	pop	param				; CRC16Sum := XOR ( CRC16Sum , XOR ( WorkCRC , _CRCGetTabElem ( Data ) ) ) ;
	rcall	_CRCGetTabElem			;
	lds	acc,WorkCRC+1			;
	eor	xh,acc				;
	lds	acc,WorkCRC			;
	eor	xl,acc				;
	lds	acc,CRC16Sum+1			;
	eor	acc,xh				;
	sts	CRC16Sum+1,acc			;
	lds	acc,CRC16Sum			;
	eor	acc,xl				;
	sts	CRC16Sum,acc			;
	ret					;END (* CRCNibleService *) ;
;-----------------------------------------------------------------------------
CRCStep :					;PROCEDURE CRCStep ( Data[param] : BYTE ) ;
;********					;BEGIN (* CRCStep *)
	push	param				;
	rcall	CRCNibleService			; CRCNibleService ( Data ) ;
	pop	param				;
	swap	param				; CRCNibleService ( Data >> 4 ) ;
	rcall	CRCNibleService			;
	ret					;END (* CRCStep *) ;
;-----------------------------------------------------------------------------
StartCRC :					;PROCEDURE StartCRC ( ) ;
;*********					;BEGIN (* StartCRC *)
	ldi	acc,0xFF			; CRC16Sum := 0x0FFFF ;
	sts	CRC16Sum+1,acc			;
	sts	CRC16Sum,acc			;
	ret					;END (* StartCRC *) ;
;-----------------------------------------------------------------------------
GetCRCSum :					;FUNCTION GetCRCSum ( ) : WORD[x] ;
;**********					;BEGIN (* GetCRCSum *)
	lds	xh,CRC16Sum+1			; GetCRCSum := CRC16Sum ;
	lds	xl,CRC16Sum			;
	ret					;END (* GetCRCSum *) ;
;-----------------------------------------------------------------------------
ComputeCRC :					;FUNCTION ComputeCRC ( Size[param] : BYTE ;
;***********					;		       DataBlock[z] : ADDRESS ) : WORD[x] ;
;						;VAR
;						; Loop[acc] : BYTE ;
;						; Buff[z] : ^ ARRAY [ 0 .. <duzo> ] OF BYTE ;
;						;BEGIN (* ComputeCRC *)
						; Buff := ADDRESS ( DataBlock ) ;
	rcall	StartCRC			; StartCRC ( ) ;
	clr	acc				; FOR Loop := 0 TO Size - 1 DO
CoCRC_0	:					; BEGIN
	push	param				;
	push	acc				;
	ld	param,z+			;  CRCStep ( Buff [ Loop ] ) ;
	rcall	CRCStep				;
	pop	acc				; END (* FOR *) ;
	inc	acc				;
	pop	param				;
	cp	acc,param			;
	brne	CoCRC_0				;
	rcall	GetCRCSum			; ComputeCRC := GetCRCSum ( ) ;
	ret					;END (* ComputeCRC *) ;;
;-----------------------------------------------------------------------------
.exit
