;
;*******************************************************
;*******************************************************
;**                                                   **
;**         Procedury obslugi interfejsu I2C          **
;**                                                   **
;**               Andrzej Pawluczuk                   **
;**                                                   **
;**              Mikrokontroler: AVR                  **
;**                                                   **
;**                Bialystok, 2005                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
;-----------------------------------------------------------------------------
.equ	_SDAPIN			= SDA_Port - 2
.equ	_SDADDR			= SDA_Port - 1
.equ	_SCLDDR			= SCL_Port - 1
;-----------------------------------------------------------------------------
I2CInitEnvir :					;PROCEDURE I2CInitEnvir ( ) ;
;*************					;BEGIN (* I2CInitEnvir *)
	sbi	_SDADDR,SDA_Pin			; [SDA] := [output] ;
	sbi	_SCLDDR,SCL_Pin			; [SCL] := [output] ;
	ret					;END I2CInitEnvir ;
;-----------------------------------------------------------------------------
I2CDelay :					;PROCEDURE I2CDelay ( ) ;
;*********					;BEGIN (* I2CDelay *)
	push	acc				;
	ldi	acc,0xC0			;
I2CD_0	:					;
	dec	acc				;
	brne	I2CD_0				;
	pop	acc				;
	ret					;END I2CDelay ;
;-----------------------------------------------------------------------------
Clock	:					;PROCEDURE Clock ( ) : BOOLEAN ;
;********					;BEGIN (* Clock *)
	push	acc				;
	rcall	I2CDelay			; I2CDelay ( ) ;
	sbi	SCL_Port,SCL_Pin		; [SCL] := 1 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	in	acc,_SDAPIN			; acc := SDAPort ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	cbi	SCL_Port,SCL_Pin		; [SCL] := 0 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	bst	acc,SDA_Pin			; RETURN ( acc[SDA] );
	brtc	Clo_0				;
	sec					;
	rjmp	Clo_1				;
Clo_0	:					;
	clc					;
Clo_1	:					;
	pop	acc				;
	ret					;END Clock ;
;-----------------------------------------------------------------------------
OutByte	:					;PROCEDURE OutByte ( Data [param] : BYTE ) ;
;********					;BEGIN (* OutByte *)
	rcall	I2CDelay			; I2CDelay ( ) ;
	ldi	acc,8				; FOR x := 7 TO 0 BY - 1 DO
OutB_0	:					;
	rol	param				;  IF Data [ x ] THEN
	brcc	OutB_1				;
	sbi	SDA_Port,SDA_Pin		;   SDA := 1 ;
	rjmp	OutB_2				;
OutB_1	:					;  ELSE
	cbi	SDA_Port,SDA_Pin		;   SDA := 0 ;
OutB_2	:					;  END (* IF ... ELSE *) ;
	rcall	Clock				;  ? := Clock ( ) ;
	dec	acc				;
	brne	OutB_0				; END (* FOR *) ;
	ret					;END OutByte ;
;-----------------------------------------------------------------------------
InByte	:					;PROCEDURE InByte ( ) : BYTE ;
;********					;BEGIN (* InByte *)
	sbi	SDA_Port,SDA_Pin		; [SDA] := 1 ;
	cbi	_SDADDR,SDA_Pin			; [SDA] := [input] ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	ldi	acc2,8				; FOR acc2 := 7 TO 0 BY - 1 DO
	ldi	acc,0				;
InB_0	:					;
	rcall	Clock				;  acc [ acc2 ] := Clock ( ) ;
	rcall	I2CDelay			;  I2CDelay ( ) ;
	rol	acc				;
	dec	acc2				;
	brne	InB_0				; END (* FOR *) ;
	sbi	_SDADDR,SDA_Pin			; [SDA] := [output] ;
	ret					;RET InByte ;
;-----------------------------------------------------------------------------
NotACK	:					;PROCEDURE NotACK ( ) ;
;********					;BEGIN (* NotACK *)
	sbi	SDA_Port,SDA_Pin		; [SDA] := 1 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	rcall	Clock				; ? := Clock ( ) ;
	ret					;END NotACK ;
;-----------------------------------------------------------------------------
GetACK	:					;PROCEDURE GetACK ( ) : BOOLEAN[C] ;
;********					;BEGIN (* GetACK *)
	sbi	SDA_Port,SDA_Pin		; [SDA] := 1 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	rcall	Clock				; ? := Clock ( ) ;
	ret					;END GetACK ;
;-----------------------------------------------------------------------------
StartI2C :					;PROCEDURE StartI2C ( ) ;
;*********					;BEGIN (* StartI2C *)
	sbi	SDA_Port,SDA_Pin		; [SDA] := 1 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	sbi	SCL_Port,SCL_Pin		; [SCL] := 1 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	cbi	SDA_Port,SDA_Pin		; [SDA] := 0 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	cbi	SCL_Port,SCL_Pin		; [SCL] := 0 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	ret					;END StartI2C ;
;-----------------------------------------------------------------------------
StopI2C	:					;PROCEDURE StopI2C ( ) ;
;********					;BEGIN (* StopI2C *)
	cbi	SDA_Port,SDA_Pin		; [SDA] := 0 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	sbi	SCL_Port,SCL_Pin		; [SCL] := 1 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	sbi	SDA_Port,SDA_Pin		; [SDA] := 1 ;
	rcall	I2CDelay			; I2CDelay ( ) ;
	ret					;END StopI2C ;
;-----------------------------------------------------------------------------
.exit
