;
;*******************************************************
;*******************************************************
;**                                                   **
;**  Biblioteka procedur obslugi operacji na          **
;**            lancuchach znakowych                   **
;**                                                   **
;**             Andrzej Pawluczuk                     **
;**                                                   **
;**            Mikrokontroler: AVR                    **
;**                                                   **
;**             Bialystok, 2006                       **
;**                                                   **
;*******************************************************
;*******************************************************
;
.message	"***>>> Dolaczenie bibioteki obslugi ciagow znakowych"
;
;*******************************************************
;*******************************************************
;
;
;
;-----------------------------------------------------------------------------
NibleToHex :					;FUNCTION NibleToHex ( Val[param] : byte ) : CHAR[acc] ;
;**********					;BEGIN (* NibleToHex *)
	pushz					;
	ldz	HexConvTable<<1			; NibleToHex := HexConvTable [ Val MOD 16 ] ;
	andi	param,0x0F			;
	clr	acc				;
	add	zl,param			;
	adc	zh,acc				;
	lpm					;
	mov	acc,r0				;
	popz					;
	ret					;END (* NibleToHex *) ;
;-----------------------------------------------------------------------------
ByteToHex :					;FUNCTION ByteToHex ( Val[param] : BYTE ) : WORD[x] ;
;**********					;VAR
;						; RetVH[stack] : CHAR ;
;						; RetVL[stack] : CHAR ;
;						;BEGIN (* ByteToHex *)
	push	param				;
	swap	param				; RetVH := NibleToHex ( Val MOD 16 ) ;
	rcall	NibleToHex			;
	pop	param				; RetVL := NibleToHex ( Val DIV 16 ) ;
	push	acc				;
	rcall	NibleToHex			;
	mov	xl,acc				; ByteToHex := RetVH << 8 + RetVL ;
	pop	xh				;
	ret					;END (* ByteToHex *) ;
;-----------------------------------------------------------------------------
ByteToBin :					;PROCEDURE ByteToBin ( VAR Number[Z] : ARRAY OF CHAR ;
;************					; 			   Value[param] : BYTE ) ;
						; VAR
						;  Loop[acc2] : BYTE ;
						;BEGIN (* ByteToBin *)
	ldi	acc2,0				; FOR Loop := 0 TO 7 DO
BiToSB_1 :					; BEGIN
	rol	param				;  Number[Loop] := Value.Loop+'0' ;
	ldi	acc,0				;
	adc	acc,acc				;
	subi	acc,-'0'			;
	st	z+,acc				;
	cpi	acc2,7				; END (* FOR *) ;
	breq	BiToSB_0			;
	inc	acc2				;
	rjmp	BiToSB_1			;
BiToSB_0 :					;
	ldi	acc,0				; Number[8] := 0 ;
	st	z,acc				;
	ret					;END (* BinToStrBin *) ;
;-----------------------------------------------------------------------------
WordToHexString :				;PROCEDURE WordToHexString ( CardV[z] : POINTER TO WORD ;
;******************				;			 VAR String[x] : ARRAY OF CHAR ;
;						;			     ConvWidth[param] : BYTE ;
;						;			     EmptyCh[acc] : CHAR ) ;
;						;VAR
;						; Inx[acc2] : BYTE ;
;						; Mod16[acc] : BYTE ;
;						;BEGIN (* WordToHexString *)
	push	zl				;
	push	zh				;
	mov	zl,xl				;
	mov	zh,xh				;
	ldi	acc2,0				; FOR Inx := 0 TO ConvWidth-1 DO
UCToHeSt_0 :					; BEGIN
	st	z+,acc				;  String [ Inx ] := EmptyCh ;
	inc	acc2				; END (* FOR *) ;
	cp	acc2,param			;
	brne	UCToHeSt_0			;
	mov	zl,xl				; String[ConvWidth] := CHR ( 0 ) ;
	mov	zh,xh				;
	add	zl,param			;
	ldi	acc,0				;
	adc	zh,acc				;
	st	z,acc				;
	dec	param				; Inx := ConvWidth - 1 ;
	mov	acc2,param			;
	pop	zh				; Argument1 := CardV ^ ;
	pop	zl				;
	ld	acc,z+				;
	mov	Argument1LL,acc			;
	ld	acc,z				;
	mov	Argument1LH,acc			;
	ldi	acc,0				;
	mov	Argument1HL,acc			;
	mov	Argument1HH,acc			;
UCToHeSt_1 :					; LOOP
	mov	acc,Argument1LL			;  Mod16 := Argument1 MOD 16 ;
	andi	acc,0x0F			;
	ldz	HexConvTable<<1			;  String [ Inx ] := HexConvTable [ Mod16 ] ;
	add	zl,acc				;
	ldi	acc,0				;
	adc	zh,acc				;
	lpm					;
	mov	zl,xl				;
	mov	zh,xh				;
	add	zl,acc2				;
	ldi	acc,0				;
	adc	zh,acc				;
	st	z,r0				;
	lsr	Argument1LH			;  Argument1 := Argument1 >> 4 ;
	ror	Argument1LL			;
	lsr	Argument1LH			;
	ror	Argument1LL			;
	lsr	Argument1LH			;
	ror	Argument1LL			;
	lsr	Argument1LH			;
	ror	Argument1LL			;
	cpi	acc2,0				;  IF (Inx=0) OR (Argument1=0) THEN
	breq	UCToHeSt_2			;
	mov	acc,Argument1LL			;
	or	acc,Argument1LH			;
	breq	UCToHeSt_2			;   EXIT ;
						;  END (* IF *) ;
	dec	acc2				;  Inx := Inx - 1 ;
	rjmp	UCToHeSt_1			; END (* LOOP *) ;
UCToHeSt_2 :					;
	ret					;END (* WordToHexString *) ;
;-----------------------------------------------------------------------------
WordToString :					;PROCEDURE WordToString ( CardV[z] : POINTER TO WORD ;
;*************					;                     VAR String[x] : ARRAY OF CHAR ;
;						;			  ConvWidth[param] : BYTE ;
;						;			  EmptyCh[acc] : CHAR ) ;
;						; VAR
;						;  Inx[acc2] : BYTE ;
;						;  ModV[WorkRegLL] : BYTE ;
;						;BEGIN (* WordToString *)
	push	zl				;
	push	zh				;
	mov	zl,xl				;
	mov	zh,xh				;
	ldi	acc2,0				; FOR Inx := 0 TO ConvWidth DO
UCToSt_0 :					;
	st	z+,acc				;  String [ Inx ] := EmptyCh ;
	inc	acc2				; END (* FOR *) ;
	cp	acc2,param			;
	brne	UCToSt_0			;
	mov	zl,xl				; String [ ConvWidth ] := CHR ( 0 ) ;
	mov	zh,xh				;
	add	zl,param			;
	ldi	acc,0				;
	adc	zh,acc				;
	st	z,acc				;
	dec	param				; Inx := ConvWidth - 1 ;
	mov	acc2,param			;
	pop	zh				; Argument1 := CardV ^ ;
	pop	zl				;
	ld	acc,z+				;
	mov	Argument1LL,acc			;
	ld	acc,z				;
	mov	Argument1LH,acc			;
	ldi	acc,0				;
	mov	Argument1HL,acc			;
	mov	Argument1HH,acc			;
UCToSt_1 :					; LOOP
	push	acc2				;
	rcall	DivModArg1By10			;  Argument2 := Argument1 DIV 10 ;
						;  ModV := Argument1 MOD 10 ;
	mov	acc,WorkRegLL			;  String [ Inx ] := CHR ( ModV + ORD ( '0' ) ) ;
	ldi	acc2,'0'			;
	add	acc,acc2			;
	pop	acc2				;
	mov	zl,xl				;
	mov	zh,xh				;
	add	zl,acc2				;
	ldi	param,0				;
	adc	zh,param			;
	st	z,acc				;
	mov	Argument1LL,Argument2LL		;  Argument1 := Argument2 ;
	mov	Argument1LH,Argument2LH		;
	cpi	acc2,0				;  IF ( Inx = 0 ) OR ( Argument1 = 0 ) THEN
	breq	UCToSt_2			;
	mov	acc,Argument1LL			;
	or	acc,Argument1LH			;
	breq	UCToSt_2			;   EXIT ;
						;  END (* IF *) ;
	dec	acc2				;  Inx := Inx - 1 ;
	rjmp	UCToSt_1			; END (* LOOP *) ;
UCToSt_2 :					;
	ret					;END (* WordToString *) ;
;-----------------------------------------------------------------------------
HexConvTable :	.db	"0123456789ABCDEF"
;-----------------------------------------------------------------------------
.exit
